<template>
  <el-cascader
    :options="options"
    :show-all-levels="false"
    :props="{
      checkStrictly: true,
      value: 'id',
      label: 'name',
      children: 'children',
    }"
    :placeholder="placeholder"
    style="width: 100%; margin-right: 10px"
    @change="handleChange"
    clearable
    ref="cascaderHandle"
    v-model="value_"
  ></el-cascader>
</template>

<script>
export default {
  props: {
    value: {
      type: Array,
      default: () => [],
    },
    placeholder: {
      type: String,
      default: '请选择',
    },
  },
  data() {
    return {
      options: [],
      childrens: [],
      value_: [],
    }
  },
  created() {
    this.getOptions()
  },
//   watch: {
//     value: {
//       deep: true,
//       handler(val) {
//         this.value_ = val
//       },
//     },
//   },
  mounted() {
    this.$nextTick(() => {
      let val = this.value
      if (!val && !(val instanceof Array)) return
      this.value_ = val[val.length - 1] // val.splice(0, 2)
    })
  },
  methods: {
    getOptions() {
      this.$http
        .get('${yhxt}/Company/v1/getTree/company/' + '1258608622670319616')
        .then((res) => {
          this.options = this.deepClone(res.data)
        })
    },
    //深层拷贝
    deepClone(obj, id) {
      let objClone = Array.isArray(obj) ? [] : {}
      if (obj && typeof obj === 'object') {
        for (let key in obj) {
          if (obj.hasOwnProperty(key)) {
            //判断ojb子元素是否为对象，如果是，递归复制
            if (obj[key] && typeof obj[key] === 'object') {
              objClone[key] = this.deepClone(obj[key])
            } else {
              objClone.label = obj.name
              objClone.value = obj.id
              //如果不是，简单复制
              objClone[key] = obj[key]
            }
          }
        }
      }
      return objClone
    },
    getChildren(obj, id) {
      for (let i in obj) {
        if (obj[i].id == id) {
          this.childrens = obj[i].children || []
        } else {
          this.getChildren(obj[i].children, id)
        }
      }
    },
    getAllChildren(obj) {
      if (Object.prototype.toString.call(obj) === '[object Array]') {
        obj.forEach((item) => {
          if (item.children) {
            this.getAllChildren(item.children)
            this.childrens.push(item)
          } else {
            this.childrens.push(item)
          }
        })
      }
    },
    handleChange(val) {
      if (!val) return
      console.log(val, 'eeeeee')
      this.$emit('change', val)
      if (this.$refs.cascaderHandle.checkedValue.length === 0) {
        this.$emit('clear')
      } else {
        if (val.length == 0) {
          this.$emit('input', '')
        } else {
          let arr = [],
            arr_ = []
          this.childrens = []
          if (val.length == 1) {
            this.getAllChildren(this.options)
          } else {
            this.getChildren(this.options, val[val.length - 1])
          }
          this.childrens.length !== 0 &&
            this.childrens.forEach((item) => {
              arr.push(item.id)
            })
          if (this.childrens.length === 0) {
            arr_.push(val[val.length - 1])
          } else {
            arr_ = [...val]
          }
          this.$emit('input', [...arr_, ...arr])
        }
      }
    },
  },
}
</script>

<style></style>
